'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var stateFromHistory = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatchId, journal, entries) {
		var state, timedOut, failures, i, entry, _state;

		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						if (entries) {
							_context.next = 4;
							break;
						}

						_context.next = 3;
						return journal.getEntries();

					case 3:
						entries = _context.sent;

					case 4:
						state = { notFound: true };
						timedOut = 0;
						failures = 0;
						i = 0;

					case 8:
						if (!(i < entries.length)) {
							_context.next = 49;
							break;
						}

						entry = entries[i];

						if (!(entry.dispatchId == dispatchId)) {
							_context.next = 46;
							break;
						}

						if (!(entry.type == 'ScheduleActivity' || entry.type == 'ScheduleChildWorkflow')) {
							_context.next = 16;
							break;
						}

						state = { scheduled: true, name: entry.name, args: entry.args, failures: failures };
						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 16:
						if (!(entry.type == 'StartedActivity' || entry.type == 'StartChildWorkflow')) {
							_context.next = 21;
							break;
						}

						state = { started: true, name: entry.name, args: entry.args, last_activity: entry.date, failures: failures };
						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 21:
						if (!(entry.type == 'Heartbeat' && state.started)) {
							_context.next = 25;
							break;
						}

						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 25:
						if (!(entry.type == 'FailedActivity' || entry.type == 'FailedChildWorkflow')) {
							_context.next = 31;
							break;
						}

						failures++;
						state = { failed: true, failures: failures };
						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 31:
						if (!(entry.type == 'QueueActivity')) {
							_context.next = 36;
							break;
						}

						state = { queue: true, failures: failures };
						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 36:
						if (!(entry.type == 'TimedOutActivity' || entry.type == 'TimedOutChildWorkflow')) {
							_context.next = 42;
							break;
						}

						timedOut++;
						state = (_state = { timedOut: true }, (0, _defineProperty3.default)(_state, 'timedOut', timedOut), (0, _defineProperty3.default)(_state, 'failures', failures), _state);
						state.last_activity = entry.date;
						_context.next = 46;
						break;

					case 42:
						if (!(entry.type == 'FinishedActivity' || entry.type == 'FinishedChildWorkflow')) {
							_context.next = 46;
							break;
						}

						state = { finished: true, result: entry.result };
						state.last_activity = entry.date;
						return _context.abrupt('return', state);

					case 46:
						i++;
						_context.next = 8;
						break;

					case 49:
						return _context.abrupt('return', state);

					case 50:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function stateFromHistory(_x, _x2, _x3) {
		return _ref.apply(this, arguments);
	};
}();

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = stateFromHistory;