'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _workflow_signals = require('../workflow_signals');

var _logger = require('../logger');

var _logger2 = _interopRequireDefault(_logger);

var _cache = require('../utils/cache.js');

var _cache2 = _interopRequireDefault(_cache);

var _blob = require('../utils/blob.js');

var _blob2 = _interopRequireDefault(_blob);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var moment = require("moment");


function activity(options) {
	options = options || {};
	var _options = options,
	    version = _options.version,
	    cache = _options.cache,
	    blob = _options.blob;

	if (!process.env.ENABLE_BLOB || blob === undefined || blob === null || blob === false) {
		blob = { result: false, input: false };
	} else if (blob === true) {
		blob = { result: true, input: true };
	}
	if (!process.env.ENABLE_CACHE) cache = false;
	return function decorator(target, name, descriptor) {
		var value = descriptor.value,
		    get = descriptor.get;

		target.isActivity = true;
		return {
			get: function getter() {
				var newDescriptor = { configurable: true };

				// If we are dealing with a getter
				if (get) {
					// Replace the getter with the processed one
					// newDescriptor.get = function(){
					// 	console.log("activity_getter inner",this);
					// 	return get();
					// };

					// Redefine the property on the instance with the new descriptor
					(0, _defineProperty2.default)(this, name, newDescriptor);

					// Return the getter result
					return newDescriptor.get();
				}
				var theFunc = function () {
					var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10() {
						var _this = this;

						var inflateBlobArguments,
						    shrinkBlobResults,
						    theArgs,
						    fn,
						    dispatchId,
						    state,
						    _args10 = arguments;
						return _regenerator2.default.wrap(function _callee10$(_context10) {
							while (1) {
								switch (_context10.prev = _context10.next) {
									case 0:
										if (!this.activityMode) {
											_context10.next = 10;
											break;
										}

										inflateBlobArguments = blob.input ? function () {
											var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(argsArray) {
												return _regenerator2.default.wrap(function _callee4$(_context4) {
													while (1) {
														switch (_context4.prev = _context4.next) {
															case 0:
																_context4.next = 2;
																return _promise2.default.all((0, _values2.default)(argsArray).map(function () {
																	var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(arg) {
																		return _regenerator2.default.wrap(function _callee3$(_context3) {
																			while (1) {
																				switch (_context3.prev = _context3.next) {
																					case 0:
																						if (!arg._blobKey) {
																							_context3.next = 2;
																							break;
																						}

																						return _context3.abrupt('return', _blob2.default.getData({ key: arg._blobKey }));

																					case 2:
																						if (!Array.isArray(arg)) {
																							_context3.next = 6;
																							break;
																						}

																						_context3.next = 5;
																						return _promise2.default.all(arg.map(function () {
																							var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(arg2) {
																								return _regenerator2.default.wrap(function _callee$(_context) {
																									while (1) {
																										switch (_context.prev = _context.next) {
																											case 0:
																												if (!arg2._blobKey) {
																													_context.next = 6;
																													break;
																												}

																												_context.next = 3;
																												return _blob2.default.getData({ key: arg2._blobKey });

																											case 3:
																												_context.t0 = _context.sent;
																												_context.next = 7;
																												break;

																											case 6:
																												_context.t0 = arg2;

																											case 7:
																												return _context.abrupt('return', _context.t0);

																											case 8:
																											case 'end':
																												return _context.stop();
																										}
																									}
																								}, _callee, _this);
																							}));

																							return function (_x3) {
																								return _ref4.apply(this, arguments);
																							};
																						}()));

																					case 5:
																						return _context3.abrupt('return', _context3.sent);

																					case 6:
																						if (!((typeof arg === 'undefined' ? 'undefined' : (0, _typeof3.default)(arg)) === 'object')) {
																							_context3.next = 12;
																							break;
																						}

																						_context3.next = 9;
																						return _promise2.default.all((0, _keys2.default)(arg).map(function () {
																							var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(key) {
																								var arg2, value;
																								return _regenerator2.default.wrap(function _callee2$(_context2) {
																									while (1) {
																										switch (_context2.prev = _context2.next) {
																											case 0:
																												arg2 = arg[key];

																												if (!arg2._blobKey) {
																													_context2.next = 7;
																													break;
																												}

																												_context2.next = 4;
																												return _blob2.default.getData({ key: arg2._blobKey });

																											case 4:
																												_context2.t0 = _context2.sent;
																												_context2.next = 8;
																												break;

																											case 7:
																												_context2.t0 = arg2;

																											case 8:
																												value = _context2.t0;

																												arg[key] = value;

																											case 10:
																											case 'end':
																												return _context2.stop();
																										}
																									}
																								}, _callee2, _this);
																							}));

																							return function (_x4) {
																								return _ref5.apply(this, arguments);
																							};
																						}()));

																					case 9:
																						return _context3.abrupt('return', arg);

																					case 12:
																						return _context3.abrupt('return', arg);

																					case 13:
																					case 'end':
																						return _context3.stop();
																				}
																			}
																		}, _callee3, _this);
																	}));

																	return function (_x2) {
																		return _ref3.apply(this, arguments);
																	};
																}()));

															case 2:
																return _context4.abrupt('return', _context4.sent);

															case 3:
															case 'end':
																return _context4.stop();
														}
													}
												}, _callee4, _this);
											}));

											return function (_x) {
												return _ref2.apply(this, arguments);
											};
										}() : function () {
											var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(a) {
												return _regenerator2.default.wrap(function _callee5$(_context5) {
													while (1) {
														switch (_context5.prev = _context5.next) {
															case 0:
																return _context5.abrupt('return', a);

															case 1:
															case 'end':
																return _context5.stop();
														}
													}
												}, _callee5, _this);
											}));

											return function (_x5) {
												return _ref6.apply(this, arguments);
											};
										}();
										shrinkBlobResults = blob.result ? function () {
											var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(result) {
												return _regenerator2.default.wrap(function _callee7$(_context7) {
													while (1) {
														switch (_context7.prev = _context7.next) {
															case 0:
																if (!Array.isArray(result)) {
																	_context7.next = 4;
																	break;
																}

																_context7.next = 3;
																return _promise2.default.all(result.map(function (arg) {
																	return _blob2.default.setData({ entry: arg });
																}));

															case 3:
																return _context7.abrupt('return', _context7.sent);

															case 4:
																if (!((typeof result === 'undefined' ? 'undefined' : (0, _typeof3.default)(result)) === 'object')) {
																	_context7.next = 8;
																	break;
																}

																_context7.next = 7;
																return _promise2.default.all((0, _keys2.default)(result).map(function () {
																	var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(key) {
																		return _regenerator2.default.wrap(function _callee6$(_context6) {
																			while (1) {
																				switch (_context6.prev = _context6.next) {
																					case 0:
																						_context6.next = 2;
																						return _blob2.default.setData({ entry: result[key] });

																					case 2:
																						result[key] = _context6.sent;

																					case 3:
																					case 'end':
																						return _context6.stop();
																				}
																			}
																		}, _callee6, _this);
																	}));

																	return function (_x7) {
																		return _ref8.apply(this, arguments);
																	};
																}()));

															case 7:
																return _context7.abrupt('return', result);

															case 8:
																_context7.next = 10;
																return _blob2.default.setData({ entry: result });

															case 10:
																return _context7.abrupt('return', _context7.sent);

															case 11:
															case 'end':
																return _context7.stop();
														}
													}
												}, _callee7, _this);
											}));

											return function (_x6) {
												return _ref7.apply(this, arguments);
											};
										}() : function () {
											var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(a) {
												return _regenerator2.default.wrap(function _callee8$(_context8) {
													while (1) {
														switch (_context8.prev = _context8.next) {
															case 0:
																return _context8.abrupt('return', a);

															case 1:
															case 'end':
																return _context8.stop();
														}
													}
												}, _callee8, _this);
											}));

											return function (_x8) {
												return _ref9.apply(this, arguments);
											};
										}();
										theArgs = _args10;

										fn = function () {
											var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
												var inflatedArgs;
												return _regenerator2.default.wrap(function _callee9$(_context9) {
													while (1) {
														switch (_context9.prev = _context9.next) {
															case 0:
																_context9.next = 2;
																return inflateBlobArguments(theArgs);

															case 2:
																inflatedArgs = _context9.sent;
																_context9.t0 = shrinkBlobResults;
																_context9.next = 6;
																return value.call.apply(value, [_this].concat((0, _toConsumableArray3.default)(inflatedArgs)));

															case 6:
																_context9.t1 = _context9.sent;
																_context9.next = 9;
																return (0, _context9.t0)(_context9.t1);

															case 9:
																return _context9.abrupt('return', _context9.sent);

															case 10:
															case 'end':
																return _context9.stop();
														}
													}
												}, _callee9, _this);
											}));

											return function fn() {
												return _ref10.apply(this, arguments);
											};
										}();

										_context10.next = 7;
										return cache ? _cache2.default.getOrInvoke({ fn: fn, key: { f: value.name.toString(), args: theArgs } }) : fn();

									case 7:
										return _context10.abrupt('return', _context10.sent);

									case 10:
										// give a canonical id - workflowid + internal activity counter
										dispatchId = this.newDispatchID(name);
										_context10.next = 13;
										return this.stateFromHistory(dispatchId);

									case 13:
										state = _context10.sent;

										if (!state.finished) {
											_context10.next = 16;
											break;
										}

										return _context10.abrupt('return', state.result);

									case 16:
										if (!state.notFound) {
											_context10.next = 18;
											break;
										}

										throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args10);

									case 18:
										if (!state.failed) {
											_context10.next = 20;
											break;
										}

										throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args10);

									case 20:
										if (!state.timedOut) {
											_context10.next = 22;
											break;
										}

										throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args10);

									case 22:
										if (!state.scheduled) {
											_context10.next = 24;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 24:
										if (!state.started) {
											_context10.next = 26;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 26:
										if (!state.queue) {
											_context10.next = 28;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 28:
										throw new _workflow_signals.WorkflowNoDecision();

									case 29:
									case 'end':
										return _context10.stop();
								}
							}
						}, _callee10, this);
					}));

					return function theFunc() {
						return _ref.apply(this, arguments);
					};
				}();
				// Process the function
				newDescriptor.value = theFunc.bind(this);

				// Redfine it on the instance with the new descriptor
				(0, _defineProperty2.default)(this, name, newDescriptor);

				// Return the processed function
				return newDescriptor.value;
			}
		};
	};
}

exports.default = activity;