"use strict";

Object.defineProperty(exports, "__esModule", {
			value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _workflow_signals = require("../workflow_signals");

var _logger = require("../logger");

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var moment = require("moment");
var AWS = require("aws-sdk");
var lambda = new AWS.Lambda({ apiVersion: '2015-03-31', region: "us-west-2" });

function lambdaActivity(functionName) {
			return function decorator(target, name, descriptor) {
						var value = descriptor.value,
						    get = descriptor.get;

						target.isActivity = true;
						return {
									get: function getter() {
												var newDescriptor = { configurable: true };

												// If we are dealing with a getter
												if (get) {
															// Replace the getter with the processed one
															// newDescriptor.get = function(){
															// 	console.log("activity_getter inner",this);
															// 	return get();
															// };

															// Redefine the property on the instance with the new descriptor
															(0, _defineProperty2.default)(this, name, newDescriptor);

															// Return the getter result
															return newDescriptor.get();
												}
												var theFunc = function () {
															var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
																		var dispatchId,
																		    state,
																		    _args = arguments;
																		return _regenerator2.default.wrap(function _callee$(_context) {
																					while (1) {
																								switch (_context.prev = _context.next) {
																											case 0:
																														if (!this.activityMode) {
																																	_context.next = 7;
																																	break;
																														}

																														_logger2.default.debug("invoking lambda", functionName);
																														_context.next = 4;
																														return lambda.invoke({
																																	FunctionName: functionName,
																																	Payload: (0, _stringify2.default)(_args)
																														}).promise().then(function (res) {
																																	var payload = JSON.parse(res.Payload);
																																	if (payload.errorMessage) {
																																				throw new Error(payload.errorMessage);
																																	} else return payload;
																														});

																											case 4:
																														return _context.abrupt("return", _context.sent);

																											case 7:
																														// give a canonical id - workflowid + internal activity counter
																														dispatchId = this.newDispatchID();
																														_context.next = 10;
																														return this.stateFromHistory(dispatchId);

																											case 10:
																														state = _context.sent;

																														if (!state.finished) {
																																	_context.next = 13;
																																	break;
																														}

																														return _context.abrupt("return", state.result);

																											case 13:
																														if (!state.notFound) {
																																	_context.next = 15;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args);

																											case 15:
																														if (!state.failed) {
																																	_context.next = 17;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args);

																											case 17:
																														if (!state.timedOut) {
																																	_context.next = 19;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowDecisionScheduleActivity(dispatchId, name, _args);

																											case 19:
																														if (!state.scheduled) {
																																	_context.next = 21;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowNoDecision();

																											case 21:
																														if (!state.started) {
																																	_context.next = 23;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowNoDecision();

																											case 23:
																														if (!state.queue) {
																																	_context.next = 25;
																																	break;
																														}

																														throw new _workflow_signals.WorkflowNoDecision();

																											case 25:
																														throw new _workflow_signals.WorkflowNoDecision();

																											case 26:
																											case "end":
																														return _context.stop();
																								}
																					}
																		}, _callee, this);
															}));

															return function theFunc() {
																		return _ref.apply(this, arguments);
															};
												}();
												// Process the function
												newDescriptor.value = theFunc.bind(this);

												// Redfine it on the instance with the new descriptor
												(0, _defineProperty2.default)(this, name, newDescriptor);

												// Return the processed function
												return newDescriptor.value;
									}
						};
			};
}

exports.default = lambdaActivity;