'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _workflow_signals = require('../workflow_signals');

var _client = require('../journal/client');

var _client2 = _interopRequireDefault(_client);

var _logger = require('../logger');

var _logger2 = _interopRequireDefault(_logger);

var _cache = require('../utils/cache.js');

var _cache2 = _interopRequireDefault(_cache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var moment = require("moment");

function workflow(options) {
	options = options || {};
	var _options = options,
	    version = _options.version,
	    cache = _options.cache;

	if (!process.env.ENABLE_CACHE) cache = false;
	return function decorator(target, name, descriptor) {
		// console.log("workflow init", value,target, name);
		var value = descriptor.value,
		    get = descriptor.get;

		target.isWorkflow = true;
		return {
			get: function getter() {
				var newDescriptor = { configurable: true };

				// If we are dealing with a getter
				if (get) {
					// Replace the getter with the processed one

					// Redefine the property on the instance with the new descriptor
					(0, _defineProperty2.default)(this, name, newDescriptor);

					// Return the getter result
					return newDescriptor.get();
				}
				var theFunc = function () {
					var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
						var _this = this;

						var theArgs,
						    fn,
						    res,
						    parent,
						    _handleDecision,
						    state,
						    dispatchId,
						    theJournal,
						    entries,
						    _args3 = arguments;

						return _regenerator2.default.wrap(function _callee3$(_context3) {
							while (1) {
								switch (_context3.prev = _context3.next) {
									case 0:
										if (!this.mainRun) {
											_context3.next = 36;
											break;
										}

										this.mainRun = false;
										_context3.next = 4;
										return this.journal.append({ type: "DecisionTaskStarted", date: new Date() });

									case 4:
										_context3.prev = 4;
										theArgs = _args3;

										fn = function () {
											var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
												return _regenerator2.default.wrap(function _callee$(_context) {
													while (1) {
														switch (_context.prev = _context.next) {
															case 0:
																_context.next = 2;
																return value.call.apply(value, [_this].concat((0, _toConsumableArray3.default)(theArgs)));

															case 2:
																return _context.abrupt('return', _context.sent);

															case 3:
															case 'end':
																return _context.stop();
														}
													}
												}, _callee, _this);
											}));

											return function fn() {
												return _ref2.apply(this, arguments);
											};
										}();

										_context3.next = 9;
										return cache ? _cache2.default.getOrInvoke({ fn: fn, key: { c: target.constructor.name.toString(), f: value.name.toString(), args: theArgs } }) : fn();

									case 9:
										res = _context3.sent;
										_context3.next = 12;
										return this.journal.append({ type: "DecisionTaskComplete", date: new Date() });

									case 12:
										_context3.next = 14;
										return this.journal.getEntries();

									case 14:
										_context3.t0 = function (e) {
											return e.type === 'WorkflowStarted';
										};

										parent = _context3.sent.find(_context3.t0).parent;
										_context3.next = 18;
										return this.journal.append({ type: "WorkflowComplete", date: new Date(), result: res, name: name, class: this.constructor.name, id: this.workflowId, parent: parent });

									case 18:
										_context3.next = 20;
										return this.scheduler.taint();

									case 20:
										_context3.next = 34;
										break;

									case 22:
										_context3.prev = 22;
										_context3.t1 = _context3['catch'](4);

										_handleDecision = function () {
											var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(e) {
												var _this2 = this;

												return _regenerator2.default.wrap(function _callee2$(_context2) {
													while (1) {
														switch (_context2.prev = _context2.next) {
															case 0:
																if (e instanceof _workflow_signals.WorkflowNoDecision) {
																	// logger.debug("no decisions for " + this.workflowId);
																}

																if (!(e instanceof _workflow_signals.WorkflowDecisionScheduleActivity)) {
																	_context2.next = 6;
																	break;
																}

																_context2.next = 4;
																return this.journal.append({ type: "ScheduleActivity", date: new Date(), dispatchId: e.dispatchId, args: e.args, name: e.name });

															case 4:
																_context2.next = 35;
																break;

															case 6:
																if (!(e instanceof _workflow_signals.WorkflowDecisionScheduleWorkflow)) {
																	_context2.next = 11;
																	break;
																}

																_context2.next = 9;
																return this.journal.append({ type: "ScheduleChildWorkflow", date: new Date(), dispatchId: e.dispatchId, args: e.args, name: e.name, class: e.class });

															case 9:
																_context2.next = 35;
																break;

															case 11:
																if (!(e instanceof _workflow_signals.WorkflowTimerDecision)) {
																	_context2.next = 18;
																	break;
																}

																_context2.next = 14;
																return this.journal.append({ type: "TimerSetup", date: new Date(), timerId: e.timerId, duration: e.duration });

															case 14:
																_context2.next = 16;
																return this.scheduler.scheduleTimer(e.duration, e.timerId);

															case 16:
																_context2.next = 35;
																break;

															case 18:
																if (!(e instanceof _workflow_signals.WorkflowDecisionContinueAsNew)) {
																	_context2.next = 23;
																	break;
																}

																_context2.next = 21;
																return this.journal.append({ type: "ContinueAsNew", date: new Date(), args: e.args, name: name, class: this.constructor.name, dispatchId: this.workflowId + "_1" });

															case 21:
																_context2.next = 35;
																break;

															case 23:
																if (!(e instanceof _workflow_signals.WorkflowDecisionMultipleDecisions)) {
																	_context2.next = 30;
																	break;
																}

																if (e.decisions.filter(function (d) {
																	return !(d instanceof _workflow_signals.WorkflowNoDecision);
																}).length === 0) {
																	// logger.debug("no decisions for multi " + this.workflowId);
																}
																_context2.next = 27;
																return _promise2.default.all(e.decisions.map(function (decision) {
																	return _handleDecision.bind(_this2)(decision);
																}));

															case 27:
																return _context2.abrupt('return', _context2.sent);

															case 30:
																if (e instanceof _workflow_signals.WorkflowDecision) {
																	_context2.next = 35;
																	break;
																}

																console.log('real error', e);
																// mark failed
																_context2.next = 34;
																return this.journal.append({ type: "DecisionTaskFailed", date: new Date(), error: e });

															case 34:
																throw e;

															case 35:
																return _context2.abrupt('return', e);

															case 36:
															case 'end':
																return _context2.stop();
														}
													}
												}, _callee2, this);
											}));

											return function _handleDecision(_x) {
												return _ref3.apply(this, arguments);
											};
										}();
										// console.log(e);


										_context3.next = 27;
										return _handleDecision.bind(this)(_context3.t1);

									case 27:
										res = _context3.sent;

										if (!(_context3.t1 instanceof _workflow_signals.WorkflowDecision)) {
											_context3.next = 32;
											break;
										}

										if (_context3.t1 instanceof _workflow_signals.WorkflowNoDecision) {}
										// logger.debug("no decisions for " + this.workflowId);

										// complete decision task
										_context3.next = 32;
										return this.journal.append({ type: "DecisionTaskComplete", date: new Date() });

									case 32:
										// notify scheduler		
										this.scheduler.taint();
										return _context3.abrupt('return', res);

									case 34:
										_context3.next = 111;
										break;

									case 36:
										if (!this.mainDispatch) {
											_context3.next = 56;
											break;
										}

										// from test and api gateway.
										this.mainDispatch = false;
										_context3.next = 40;
										return this.workflowStateFromHistory();

									case 40:
										state = _context3.sent;

										if (!state.finished) {
											_context3.next = 43;
											break;
										}

										return _context3.abrupt('return', state.result);

									case 43:
										if (!state.failed) {
											_context3.next = 45;
											break;
										}

										throw state.result;

									case 45:
										if (!state.notFound) {
											_context3.next = 51;
											break;
										}

										_context3.next = 48;
										return this.journal.append({ type: "WorkflowStarted", date: new Date(), args: _args3, name: name, class: this.constructor.name, parent: this.parentWorkflow });

									case 48:
										_context3.next = 50;
										return this.scheduler.taint();

									case 50:
										throw new _workflow_signals.WorkflowNoDecision();

									case 51:
										if (!state.started) {
											_context3.next = 53;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 53:
										throw new _workflow_signals.WorkflowNoDecision();

									case 56:
										if (!this.innerDispatch) {
											_context3.next = 89;
											break;
										}

										_context3.next = 59;
										return this.workflowStateFromHistory();

									case 59:
										state = _context3.sent;

										if (!state.finished) {
											_context3.next = 64;
											break;
										}

										return _context3.abrupt('return', state.result);

									case 64:
										if (!state.failed) {
											_context3.next = 68;
											break;
										}

										throw state.result;

									case 68:
										if (!state.notFound) {
											_context3.next = 76;
											break;
										}

										_context3.next = 71;
										return this.journal.append({ type: "WorkflowStarted", date: new Date(), args: _args3, name: name, class: this.constructor.name, parent: this.parentWorkflow });

									case 71:
										_context3.next = 73;
										return this.scheduler.taint();

									case 73:
										throw new _workflow_signals.WorkflowNoDecision();

									case 76:
										if (!state.started) {
											_context3.next = 80;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 80:
										if (!state.queue) {
											_context3.next = 84;
											break;
										}

										throw new _workflow_signals.WorkflowNoDecision();

									case 84:
										_logger2.default.warn("innerDispatch in unknown state ", state, this.workflowId);
										_context3.next = 87;
										return this.scheduler.taint();

									case 87:
										_context3.next = 111;
										break;

									case 89:
										// child workflow
										dispatchId = this.newDispatchID(this.constructor.name + "." + name);
										theJournal = _client2.default.getJournal(dispatchId);
										_context3.next = 93;
										return theJournal.getEntries();

									case 93:
										entries = _context3.sent;
										parent = entries.find(function (e) {
											return e.type === 'WorkflowStarted';
										});

										if (parent) {
											parent = parent.parent;
											if (!parent) {
												_logger2.default.error("child workflow with no parent " + dispatchId);
												// throw new Error("child workflow with no parent " + dispatchId);
											}
										} else {
												// logger.warn("child workflow with no start " + dispatchId)
												// throw new Error("child workflow with start " + dispatchId);
											}

										_context3.next = 98;
										return this.workflowStateFromHistory(theJournal);

									case 98:
										state = _context3.sent;

										if (!state.notFound) {
											_context3.next = 101;
											break;
										}

										throw new _workflow_signals.WorkflowDecisionScheduleWorkflow(dispatchId, name, _args3, this.constructor.name);

									case 101:
										if (!state.failed) {
											_context3.next = 103;
											break;
										}

										throw new _workflow_signals.WorkflowDecisionScheduleWorkflow(dispatchId, name, _args3, this.constructor.name);

									case 103:
										if (!state.finished) {
											_context3.next = 105;
											break;
										}

										return _context3.abrupt('return', state.result);

									case 105:
										if (!(moment().diff(moment(state.last_activity).utc(), 'minutes') > 10)) {
											_context3.next = 110;
											break;
										}

										_logger2.default.warn("WorkflowTimeout", this.workflowId);
										_context3.next = 109;
										return theJournal.append({ type: "WorkflowTimeout", date: new Date(), dispatchId: dispatchId });

									case 109:
										throw new _workflow_signals.WorkflowDecisionScheduleWorkflow(dispatchId, name, _args3, this.constructor.name);

									case 110:
										throw new _workflow_signals.WorkflowNoDecision();

									case 111:
									case 'end':
										return _context3.stop();
								}
							}
						}, _callee3, this, [[4, 22]]);
					}));

					return function theFunc() {
						return _ref.apply(this, arguments);
					};
				}();
				// Process the function	      
				newDescriptor.value = theFunc.bind(this);
				// Redfine it on the instance with the new descriptor
				(0, _defineProperty2.default)(this, name, newDescriptor);

				// Return the processed function
				return newDescriptor.value;
			}
		};
	};
}
exports.default = workflow;