"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.lambdaActivity = exports.server = exports.workflowLoader = exports.schedulerClient = exports.activity = exports.WorkflowController = exports.workflow = exports.Worker = exports.workflowFactory = undefined;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _workflow_controller = require("./workflow_controller");

var _workflow_controller2 = _interopRequireDefault(_workflow_controller);

var _workflow = require("./annotations/workflow");

var _workflow2 = _interopRequireDefault(_workflow);

var _activity = require("./annotations/activity");

var _activity2 = _interopRequireDefault(_activity);

var _lambda_activity = require("./annotations/lambda_activity");

var _lambda_activity2 = _interopRequireDefault(_lambda_activity);

var _worker = require("./worker");

var _worker2 = _interopRequireDefault(_worker);

var _workflow_factory = require("./workflow_factory");

var _workflow_factory2 = _interopRequireDefault(_workflow_factory);

var _client = require("./scheduler/client");

var _client2 = _interopRequireDefault(_client);

var _server = require("./server");

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

require("babel-core/register");
require("babel-polyfill");

var fs = require("fs");

var WorkflowLoader = function () {
    function WorkflowLoader() {
        (0, _classCallCheck3.default)(this, WorkflowLoader);
    }

    (0, _createClass3.default)(WorkflowLoader, [{
        key: "load",
        value: function load(path) {
            fs.readdirSync(path).forEach(function (file) {
                require(path + "/" + file);
            });
        }
    }]);
    return WorkflowLoader;
}();

var workflowLoader = new WorkflowLoader();

exports.workflowFactory = _workflow_factory2.default;
exports.Worker = _worker2.default;
exports.workflow = _workflow2.default;
exports.WorkflowController = _workflow_controller2.default;
exports.activity = _activity2.default;
exports.schedulerClient = _client2.default;
exports.workflowLoader = workflowLoader;
exports.server = _server2.default;
exports.lambdaActivity = _lambda_activity2.default;