'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _config = require('../config/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jayson = require('jayson/promise');

var client = jayson.client.http(_config2.default.get('JOB_QUEUE_SERVICE_ENDPOINT') || 'http://localhost:4002');

var JobQueue = function () {
	function JobQueue(id) {
		(0, _classCallCheck3.default)(this, JobQueue);

		this.id = id;
	}

	(0, _createClass3.default)(JobQueue, [{
		key: 'putJob',
		value: function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(job) {
				var res;
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return client.request('putJob', { job: job, id: this.id });

							case 2:
								res = _context.sent;

								if (!res.error) {
									_context.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function putJob(_x) {
				return _ref.apply(this, arguments);
			}

			return putJob;
		}()
	}, {
		key: 'getJob',
		value: function () {
			var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
				var res;
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.next = 2;
								return client.request('getJob', { id: this.id });

							case 2:
								res = _context2.sent;

								if (!res.error) {
									_context2.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context2.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function getJob() {
				return _ref2.apply(this, arguments);
			}

			return getJob;
		}()
	}]);
	return JobQueue;
}();

var JobQueueService = function () {
	function JobQueueService() {
		(0, _classCallCheck3.default)(this, JobQueueService);

		this.queues = {};
	}

	(0, _createClass3.default)(JobQueueService, [{
		key: 'getJobQueue',
		value: function getJobQueue(id) {
			var queue = this.queues[id];
			if (!queue) {
				this.queues[id] = queue = new JobQueue(id);
			}
			return queue;
		}
	}]);
	return JobQueueService;
}();

exports.default = new JobQueueService();