'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _config = require('../config/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jayson = require('jayson/promise');

// Connection url

var client = jayson.client.http(_config2.default.get('JOURNAL_SERVICE_ENDPOINT') || 'http://localhost:4001');

var Journal = function () {
	function Journal(id) {
		(0, _classCallCheck3.default)(this, Journal);

		this.id = id;
		this.entries = null;
	}

	(0, _createClass3.default)(Journal, [{
		key: 'getEntries',
		value: function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
				var res;
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								if (!(this.entries == null)) {
									_context.next = 7;
									break;
								}

								_context.next = 3;
								return client.request('getEntries', { id: this.id });

							case 3:
								res = _context.sent;

								if (!res.error) {
									_context.next = 6;
									break;
								}

								throw res.error;

							case 6:
								this.entries = res.result;

							case 7:
								return _context.abrupt('return', this.entries);

							case 8:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function getEntries() {
				return _ref.apply(this, arguments);
			}

			return getEntries;
		}()
	}, {
		key: 'clear',
		value: function () {
			var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
				var res;
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								this.entries = [];
								_context2.next = 3;
								return client.request('clear', { id: this.id });

							case 3:
								res = _context2.sent;

								if (!res.error) {
									_context2.next = 6;
									break;
								}

								throw res.error;

							case 6:
								return _context2.abrupt('return', res.result);

							case 7:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function clear() {
				return _ref2.apply(this, arguments);
			}

			return clear;
		}()
	}, {
		key: 'append',
		value: function () {
			var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(entry) {
				var res;
				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								_context3.next = 2;
								return this.getEntries();

							case 2:
								this.entries = _context3.sent;

								if (!this.entries) this.entries = [];
								this.entries.push({ entry: entry, id: this.id });
								// console.log("journal:",this.id,entry);
								_context3.next = 7;
								return client.request('append', { entry: entry, id: this.id });

							case 7:
								res = _context3.sent;

								if (!res.error) {
									_context3.next = 10;
									break;
								}

								throw res.error;

							case 10:
								return _context3.abrupt('return', true);

							case 11:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this);
			}));

			function append(_x) {
				return _ref3.apply(this, arguments);
			}

			return append;
		}()
	}]);
	return Journal;
}();

var JournalService = function () {
	function JournalService() {
		(0, _classCallCheck3.default)(this, JournalService);

		this.journals = {};
	}

	(0, _createClass3.default)(JournalService, [{
		key: 'getJournal',
		value: function getJournal(id) {
			var journal = this.journals[id];
			if (!journal) {
				journal = new Journal(id);
				// this.journals[id] = journal
			}
			return journal;
		}
	}, {
		key: 'getJournals',
		value: function () {
			var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.next = 2;
								return client.request('getJournals', { debug: true });

							case 2:
								return _context4.abrupt('return', _context4.sent);

							case 3:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, this);
			}));

			function getJournals() {
				return _ref4.apply(this, arguments);
			}

			return getJournals;
		}()
	}]);
	return JournalService;
}();

exports.default = new JournalService();