"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _logger = require("../logger");

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var innerQueues = {};

var plugin = {
    init: function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function init() {
            return _ref.apply(this, arguments);
        }

        return init;
    }(),
    putJob: function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref3) {
            var job = _ref3.job,
                id = _ref3.id;
            var innerQueue;
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            // console.log("putJob",id,job)
                            _logger2.default.debug("put job " + id, job);
                            innerQueue = innerQueues[id];

                            if (!innerQueue) {
                                innerQueue = [];
                                innerQueues[id] = innerQueue;
                            }
                            innerQueue.unshift(job);
                            _logger2.default.debug("job queue " + id + " " + innerQueue.length);

                        case 5:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function putJob(_x) {
            return _ref2.apply(this, arguments);
        }

        return putJob;
    }(),
    getJob: function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref5) {
            var id = _ref5.id;

            var _getJob, res;

            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            _getJob = function _getJob() {
                                var innerQueue = innerQueues[id];
                                if (!innerQueue || !innerQueue.length) return;
                                _logger2.default.debug("job queue " + id + " " + innerQueue.length);
                                switch (process.env.QUEUE_TYPE) {
                                    case "random":
                                        return innerQueue.splice(Math.floor(Math.random() * innerQueue.length), 1);
                                    case "lifo":
                                        return innerQueue.splice(0, 1);
                                    default:
                                        // and case "fifo":
                                        return [innerQueue.pop()];
                                }
                            };
                            // console.log("getJob", id)	


                            res = _getJob();

                            if (!(res && res.length)) {
                                _context3.next = 4;
                                break;
                            }

                            return _context3.abrupt("return", res[0]);

                        case 4:
                        case "end":
                            return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));

        function getJob(_x2) {
            return _ref4.apply(this, arguments);
        }

        return getJob;
    }()
};

exports.default = plugin;