'use strict';

Object.defineProperty(exports, "__esModule", {
		value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _config = require('../../config/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MongoClient = require('mongodb').MongoClient,
    test = require('assert');
var Promise = require('bluebird');

// Connection url
var url = _config2.default.get('MONGO_DB_CONNECTION_STRING') || 'mongodb://localhost:27017/test2';
var db = void 0;
// TODO: lookup between id and collection name
var plugin = {
		init: function () {
				var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
						return _regenerator2.default.wrap(function _callee$(_context) {
								while (1) {
										switch (_context.prev = _context.next) {
												case 0:
														_context.prev = 0;
														_context.next = 3;
														return MongoClient.connect(url, { db: { j: true, w: 'majority', wtimeout: 1000, readConcern: { level: 'majority' } }, j: true, w: 'majority', wtimeout: 1000, readConcern: { level: 'majority' } });

												case 3:
														db = _context.sent;
														_context.next = 9;
														break;

												case 6:
														_context.prev = 6;
														_context.t0 = _context['catch'](0);

														process.exit(-1);

												case 9:
												case 'end':
														return _context.stop();
										}
								}
						}, _callee, this, [[0, 6]]);
				}));

				function init() {
						return _ref.apply(this, arguments);
				}

				return init;
		}(),
		getEntries: function () {
				var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref3) {
						var id = _ref3.id;
						var col, results;
						return _regenerator2.default.wrap(function _callee2$(_context2) {
								while (1) {
										switch (_context2.prev = _context2.next) {
												case 0:
														col = db.collection(id);
														_context2.next = 3;
														return col.find({}).sort({ date: 1 }).toArray();

												case 3:
														results = _context2.sent;
														return _context2.abrupt('return', results);

												case 5:
												case 'end':
														return _context2.stop();
										}
								}
						}, _callee2, this);
				}));

				function getEntries(_x) {
						return _ref2.apply(this, arguments);
				}

				return getEntries;
		}(),
		getJournals: function () {
				var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref5) {
						var debug = _ref5.debug;
						var collections, results;
						return _regenerator2.default.wrap(function _callee3$(_context3) {
								while (1) {
										switch (_context3.prev = _context3.next) {
												case 0:
														_context3.next = 2;
														return db.collections();

												case 2:
														collections = _context3.sent;
														results = collections.map(function (c) {
																return c.collectionName;
														});
														return _context3.abrupt('return', results);

												case 5:
												case 'end':
														return _context3.stop();
										}
								}
						}, _callee3, this);
				}));

				function getJournals(_x2) {
						return _ref4.apply(this, arguments);
				}

				return getJournals;
		}(),
		clear: function () {
				var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref7) {
						var id = _ref7.id;
						var col;
						return _regenerator2.default.wrap(function _callee4$(_context4) {
								while (1) {
										switch (_context4.prev = _context4.next) {
												case 0:
														col = db.collection(id);
														_context4.next = 3;
														return col.drop();

												case 3:
												case 'end':
														return _context4.stop();
										}
								}
						}, _callee4, this);
				}));

				function clear(_x3) {
						return _ref6.apply(this, arguments);
				}

				return clear;
		}(),
		append: function () {
				var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(_ref9) {
						var entry = _ref9.entry,
						    id = _ref9.id;
						var col;
						return _regenerator2.default.wrap(function _callee5$(_context5) {
								while (1) {
										switch (_context5.prev = _context5.next) {
												case 0:
														col = db.collection(id);
														_context5.next = 3;
														return col.insertOne(entry);

												case 3:
												case 'end':
														return _context5.stop();
										}
								}
						}, _callee5, this);
				}));

				function append(_x4) {
						return _ref8.apply(this, arguments);
				}

				return append;
		}()
};

exports.default = plugin;