'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _client = require('../journal/client');

var _client2 = _interopRequireDefault(_client);

var _workflow_factory = require('../workflow_factory');

var _workflow_factory2 = _interopRequireDefault(_workflow_factory);

var _workflow_signals = require('../workflow_signals');

var _client3 = require('../job_queue/client');

var _client4 = _interopRequireDefault(_client3);

var _config = require('../config/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jayson = require('jayson/promise');

var client = jayson.client.http(_config2.default.get('SCHEDULER_SERVICE_ENDPOINT') || 'http://localhost:4003');

var Scheduler = function () {
	function Scheduler(workflowId) {
		(0, _classCallCheck3.default)(this, Scheduler);

		this.workflowId = workflowId;
		this.journal = _client2.default.getJournal(workflowId);
		this.decisionTasks = _client4.default.getJobQueue("decisions");
		this.activityTasks = _client4.default.getJobQueue("activities");
	}

	(0, _createClass3.default)(Scheduler, [{
		key: 'scheduleTimer',
		value: function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(duration, timerId) {
				var res;
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return client.request('scheduleTimer', { workflowId: this.workflowId, duration: duration, timerId: timerId });

							case 2:
								res = _context.sent;

								if (!res.error) {
									_context.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function scheduleTimer(_x, _x2) {
				return _ref.apply(this, arguments);
			}

			return scheduleTimer;
		}()
	}, {
		key: 'signal',
		value: function () {
			var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(signalId, result) {
				var res;
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.next = 2;
								return client.request('signal', { workflowId: this.workflowId, result: result, signalId: signalId });

							case 2:
								res = _context2.sent;

								if (!res.error) {
									_context2.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context2.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function signal(_x3, _x4) {
				return _ref2.apply(this, arguments);
			}

			return signal;
		}()
	}, {
		key: 'taint',
		value: function () {
			var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
				var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				var res;
				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								_context3.next = 2;
								return client.request('taint', { workflowId: this.workflowId, recovery: data.recovery });

							case 2:
								res = _context3.sent;

								if (!res.error) {
									_context3.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context3.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this);
			}));

			function taint() {
				return _ref3.apply(this, arguments);
			}

			return taint;
		}()
	}]);
	return Scheduler;
}();

var SchedulerService = function () {
	function SchedulerService() {
		(0, _classCallCheck3.default)(this, SchedulerService);

		this.schedulers = {};
	}

	(0, _createClass3.default)(SchedulerService, [{
		key: 'getScheduler',
		value: function getScheduler(id) {
			var scheduler = this.schedulers[id];
			if (!scheduler) {
				this.schedulers[id] = scheduler = new Scheduler(id);
			}
			return scheduler;
		}
	}, {
		key: 'run',
		value: function () {
			var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref5) {
				var className = _ref5.className,
				    name = _ref5.name,
				    args = _ref5.args,
				    id = _ref5.id;
				var res;
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.next = 2;
								return client.request('run', { className: className, name: name, args: args, id: id });

							case 2:
								res = _context4.sent;

								if (!res.error) {
									_context4.next = 5;
									break;
								}

								throw res.error;

							case 5:
								return _context4.abrupt('return', res.result);

							case 6:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, this);
			}));

			function run(_x6) {
				return _ref4.apply(this, arguments);
			}

			return run;
		}()
	}]);
	return SchedulerService;
}();

exports.default = new SchedulerService();