'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _run = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref2) {
		var className = _ref2.className,
		    name = _ref2.name,
		    args = _ref2.args,
		    id = _ref2.id;
		var classFn, workflow;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.prev = 0;
						classFn = _workflow_factory2.default[className];
						workflow = new classFn(id);

						workflow.mainDispatch = true;
						_logger2.default.info("running " + id);
						_context.next = 7;
						return workflow[name].apply(workflow, (0, _toConsumableArray3.default)(args));

					case 7:
						return _context.abrupt('return', _context.sent);

					case 10:
						_context.prev = 10;
						_context.t0 = _context['catch'](0);

						if (!(_context.t0 instanceof _workflow_signals.WorkflowDecision)) {
							_context.next = 16;
							break;
						}

						_context.next = 15;
						return srv.taint({ workflowId: id, recovery: true });

					case 15:
						return _context.abrupt('return');

					case 16:
						_logger2.default.info('run failed', _context.t0);
						throw _context.t0;

					case 18:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this, [[0, 10]]);
	}));

	return function _run(_x) {
		return _ref.apply(this, arguments);
	};
}();

var _taint = function () {
	var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref4) {
		var workflowId = _ref4.workflowId,
		    recovery = _ref4.recovery,
		    external = _ref4.external;
		var scheduler;
		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						if (external) {
							scheduler = _client6.default.getScheduler(workflowId);
						} else scheduler = srv;
						_context2.next = 3;
						return scheduler.taint({ workflowId: workflowId, recovery: recovery });

					case 3:
						return _context2.abrupt('return', _context2.sent);

					case 4:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function _taint(_x2) {
		return _ref3.apply(this, arguments);
	};
}();

var _workflow_signals = require('../workflow_signals');

var _client = require('../job_queue/client');

var _client2 = _interopRequireDefault(_client);

var _workflow_factory = require('../workflow_factory');

var _workflow_factory2 = _interopRequireDefault(_workflow_factory);

var _client3 = require('../journal/client');

var _client4 = _interopRequireDefault(_client3);

var _client5 = require('../scheduler/client');

var _client6 = _interopRequireDefault(_client5);

var _logger = require('../logger');

var _logger2 = _interopRequireDefault(_logger);

var _workflow_state_helper = require('../workflow_state_helper');

var _workflow_state_helper2 = _interopRequireDefault(_workflow_state_helper);

var _activity_state_helper = require('../activity_state_helper');

var _activity_state_helper2 = _interopRequireDefault(_activity_state_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jayson = require('jayson/promise');
var moment = require("moment");


function delay(time) {
	return new _promise2.default(function (fulfill) {
		setTimeout(fulfill, time);
	});
}

var srv = {
	run: function () {
		var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref6) {
			var className = _ref6.className,
			    name = _ref6.name,
			    args = _ref6.args,
			    id = _ref6.id;
			return _regenerator2.default.wrap(function _callee3$(_context3) {
				while (1) {
					switch (_context3.prev = _context3.next) {
						case 0:
							_context3.next = 2;
							return _run({ className: className, name: name, args: args, id: id });

						case 2:
							return _context3.abrupt('return', _context3.sent);

						case 3:
						case 'end':
							return _context3.stop();
					}
				}
			}, _callee3, this);
		}));

		function run(_x3) {
			return _ref5.apply(this, arguments);
		}

		return run;
	}(),
	recover: function () {
		var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
			var _this = this;

			var journals, journals_with_entries;
			return _regenerator2.default.wrap(function _callee5$(_context5) {
				while (1) {
					switch (_context5.prev = _context5.next) {
						case 0:
							_context5.next = 2;
							return delay(5000);

						case 2:
							_context5.next = 4;
							return _client4.default.getJournals();

						case 4:
							journals = _context5.sent;
							_context5.next = 7;
							return _promise2.default.all(journals.result.map(function () {
								var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(j) {
									var journal, entries;
									return _regenerator2.default.wrap(function _callee4$(_context4) {
										while (1) {
											switch (_context4.prev = _context4.next) {
												case 0:
													journal = _client4.default.getJournal(j);
													_context4.next = 3;
													return journal.getEntries();

												case 3:
													entries = _context4.sent;

													if (entries.find(function (e) {
														return e.type === "WorkflowStarted";
													})) {
														_context4.next = 6;
														break;
													}

													return _context4.abrupt('return', _promise2.default.resolve());

												case 6:
													if (entries.find(function (e) {
														return e.type === "WorkflowComplete";
													})) {
														_context4.next = 11;
														break;
													}

													_logger2.default.debug("Recovering", j);
													return _context4.abrupt('return', srv.taint({ workflowId: j, recovery: true }));

												case 11:
													return _context4.abrupt('return', _promise2.default.resolve());

												case 12:
												case 'end':
													return _context4.stop();
											}
										}
									}, _callee4, _this);
								}));

								return function (_x4) {
									return _ref8.apply(this, arguments);
								};
							}()));

						case 7:
							journals_with_entries = _context5.sent;

						case 8:
						case 'end':
							return _context5.stop();
					}
				}
			}, _callee5, this);
		}));

		function recover() {
			return _ref7.apply(this, arguments);
		}

		return recover;
	}(),
	scheduleTimer: function () {
		var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(_ref10) {
			var duration = _ref10.duration,
			    timerId = _ref10.timerId,
			    workflowId = _ref10.workflowId;
			var journal, decisionTasks;
			return _regenerator2.default.wrap(function _callee6$(_context6) {
				while (1) {
					switch (_context6.prev = _context6.next) {
						case 0:
							_context6.next = 2;
							return delay(duration * 1000);

						case 2:
							journal = _client4.default.getJournal(workflowId);
							_context6.next = 5;
							return journal.append({ type: "TimerFired", date: new Date(), timerId: timerId });

						case 5:
							_context6.next = 7;
							return journal.append({ type: "DecisionTaskSchedule", date: new Date() });

						case 7:
							decisionTasks = _client2.default.getJobQueue("decisions");
							_context6.next = 10;
							return decisionTasks.putJob({ workflowId: workflowId });

						case 10:
						case 'end':
							return _context6.stop();
					}
				}
			}, _callee6, this);
		}));

		function scheduleTimer(_x5) {
			return _ref9.apply(this, arguments);
		}

		return scheduleTimer;
	}(),
	signal: function () {
		var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(_ref12) {
			var workflowId = _ref12.workflowId,
			    signalId = _ref12.signalId,
			    result = _ref12.result;
			var journal, decisionTasks;
			return _regenerator2.default.wrap(function _callee7$(_context7) {
				while (1) {
					switch (_context7.prev = _context7.next) {
						case 0:
							journal = _client4.default.getJournal(workflowId);
							_context7.next = 3;
							return journal.append({ type: "SignalFired", date: new Date(), result: result, signalId: signalId });

						case 3:
							_context7.next = 5;
							return journal.append({ type: "DecisionTaskSchedule", date: new Date() });

						case 5:
							decisionTasks = _client2.default.getJobQueue("decisions");
							_context7.next = 8;
							return decisionTasks.putJob({ workflowId: workflowId });

						case 8:
						case 'end':
							return _context7.stop();
					}
				}
			}, _callee7, this);
		}));

		function signal(_x6) {
			return _ref11.apply(this, arguments);
		}

		return signal;
	}(),
	taint: function () {
		var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(_ref14) {
			var workflowId = _ref14.workflowId,
			    recovery = _ref14.recovery;
			var decisionTasks, activityTasks, journal, parent, entries, tasks, childWorkflows, lastDecisionTaskState, needANewDecisionTask, lastDecisionTaskDate, i, entry, failedCount, finished, parentJournal, tasksIds, taskId, task, state, childWorkflowsIds, childWorkflowId, childWorkflow, childJournal, classFn;
			return _regenerator2.default.wrap(function _callee8$(_context8) {
				while (1) {
					switch (_context8.prev = _context8.next) {
						case 0:
							decisionTasks = _client2.default.getJobQueue("decisions");
							activityTasks = _client2.default.getJobQueue("activities");
							journal = _client4.default.getJournal(workflowId);
							_context8.next = 5;
							return journal.getEntries();

						case 5:
							entries = _context8.sent;

							if (!entries.find(function (e) {
								return e.type === 'Archive';
							})) {
								_context8.next = 8;
								break;
							}

							return _context8.abrupt('return');

						case 8:
							if (!(entries.length > 0 && entries[entries.length - 1].type === 'Taint')) {
								_context8.next = 11;
								break;
							}

							if (!(moment().diff(moment(entries[entries.length - 1].date).utc(), 'seconds') < 25)) {
								_context8.next = 11;
								break;
							}

							return _context8.abrupt('return');

						case 11:
							_context8.next = 13;
							return journal.append({ type: "Taint", date: new Date(), entries_count: entries.length, recovery: recovery });

						case 13:
							// console.log("entries",entries)
							// add schedule if last activity completed or failed
							_logger2.default.debug('in taint', workflowId, entries.length);
							tasks = {};
							childWorkflows = {};
							lastDecisionTaskState = "notfound";
							needANewDecisionTask = true;
							i = 0;

						case 19:
							if (!(i < entries.length)) {
								_context8.next = 103;
								break;
							}

							entry = entries[i];
							_context8.t0 = entry.type;
							_context8.next = _context8.t0 === "FinishedActivity" ? 24 : _context8.t0 === "ScheduleActivity" ? 27 : _context8.t0 === "QueueActivity" ? 31 : _context8.t0 === "FailedActivity" ? 33 : _context8.t0 === "StartedActivity" ? 37 : _context8.t0 === "DecisionTaskSchedule" ? 40 : _context8.t0 === "DecisionTaskQueued" ? 43 : _context8.t0 === "DecisionTaskStarted" ? 45 : _context8.t0 === "DecisionTaskComplete" ? 49 : _context8.t0 === "DecisionTaskFailed" ? 51 : _context8.t0 === "DecisionTaskTimeOut" ? 54 : _context8.t0 === 'ScheduleChildWorkflow' ? 57 : _context8.t0 === 'StartChildWorkflow' ? 62 : _context8.t0 === 'FailedChildWorkflow' ? 64 : _context8.t0 === 'TimedOutChildWorkflow' ? 68 : _context8.t0 === 'FinishedChildWorkflow' ? 71 : _context8.t0 === 'WorkflowStarted' ? 74 : _context8.t0 === 'ContinueAsNew' ? 76 : _context8.t0 === 'WorkflowComplete' ? 78 : _context8.t0 === 'WorkflowFailed' ? 89 : 100;
							break;

						case 24:
							needANewDecisionTask = true;
							tasks[entry.dispatchId].finished = true;
							return _context8.abrupt('break', 100);

						case 27:
							failedCount = 0;

							if (tasks[entry.dispatchId]) failedCount = tasks[entry.dispatchId].failedCount;
							tasks[entry.dispatchId] = { schedule: true, failedCount: failedCount };
							return _context8.abrupt('break', 100);

						case 31:
							if (!recovery) tasks[entry.dispatchId].queued = true;
							return _context8.abrupt('break', 100);

						case 33:
							needANewDecisionTask = true;
							tasks[entry.dispatchId].failed = true;
							if (!tasks[entry.dispatchId].failedCount) {
								tasks[entry.dispatchId].failedCount = 1;
							} else {
								tasks[entry.dispatchId].failedCount++;
							}
							return _context8.abrupt('break', 100);

						case 37:
							tasks[entry.dispatchId].started = true;
							tasks[entry.dispatchId].queued = false;
							return _context8.abrupt('break', 100);

						case 40:
							lastDecisionTaskState = "schedule";
							if (!recovery) {
								needANewDecisionTask = false;
							}
							return _context8.abrupt('break', 100);

						case 43:
							if (!recovery) {
								lastDecisionTaskState = "queue";
								lastDecisionTaskDate = entry.date;
								needANewDecisionTask = false;
							}
							return _context8.abrupt('break', 100);

						case 45:
							lastDecisionTaskState = "start";
							lastDecisionTaskDate = entry.date;
							needANewDecisionTask = false;
							return _context8.abrupt('break', 100);

						case 49:
							lastDecisionTaskState = "complete";
							return _context8.abrupt('break', 100);

						case 51:
							lastDecisionTaskState = "fail";
							needANewDecisionTask = true;
							return _context8.abrupt('break', 100);

						case 54:
							lastDecisionTaskState = "timeout";
							needANewDecisionTask = true;
							return _context8.abrupt('break', 100);

						case 57:
							failedCount = 0;
							finished = false;

							if (childWorkflows[entry.dispatchId]) {
								failedCount = childWorkflows[entry.dispatchId].failedCount;
								finished = childWorkflows[entry.dispatchId].finished;
							}
							if (!finished) childWorkflows[entry.dispatchId] = { schedule: true, args: entry.args, name: entry.name, class: entry.class, failedCount: failedCount };
							return _context8.abrupt('break', 100);

						case 62:
							childWorkflows[entry.dispatchId].started = true;
							return _context8.abrupt('break', 100);

						case 64:
							childWorkflows[entry.dispatchId].failed = true;
							if (!childWorkflows[entry.dispatchId].failedCount) {
								childWorkflows[entry.dispatchId].failedCount = 1;
							} else childWorkflows[entry.dispatchId].failedCount++;
							needANewDecisionTask = true;
							return _context8.abrupt('break', 100);

						case 68:
							childWorkflows[entry.dispatchId].timedOut = true;
							needANewDecisionTask = true;
							return _context8.abrupt('break', 100);

						case 71:
							childWorkflows[entry.dispatchId].finished = true;
							needANewDecisionTask = true;
							return _context8.abrupt('break', 100);

						case 74:
							parent = entry;
							return _context8.abrupt('break', 100);

						case 76:
							childWorkflows[entry.dispatchId] = { schedule: true, args: entry.args, name: entry.name, class: entry.class };
							return _context8.abrupt('break', 100);

						case 78:
							// release waiting callbacks
							// needANewDecisionTask = false;										
							// taint parent					
							_logger2.default.info("WorkflowComplete " + workflowId);

							if (!(parent && parent.parent)) {
								_context8.next = 87;
								break;
							}

							parentJournal = _client4.default.getJournal(parent.parent);
							// var classFn = workflowFactory[entry.class];
							// console.log(classFn ,childWorkflow.class)
							// var instance = new classFn(entry.parent);
							// instance.parentWorkflow = workflowId;

							_context8.next = 83;
							return parentJournal.append({ type: "FinishedChildWorkflow", date: entry.date, result: entry.result, dispatchId: entry.id });

						case 83:
							_context8.next = 85;
							return _taint({ workflowId: parent.parent, recovery: recovery });

						case 85:
							_context8.next = 87;
							return journal.append({ type: "Archive", date: new Date() });

						case 87:
							return _context8.abrupt('return');

						case 89:
							// release waiting callbacks
							// needANewDecisionTask = false;										
							// taint parent
							// console.log("parent",parent);
							_logger2.default.warn("Taint - FailedChildWorkflow " + workflowId);

							if (!(parent && parent.parent)) {
								_context8.next = 98;
								break;
							}

							// console.log(parent.parent);
							// discover parent
							parentJournal = _client4.default.getJournal(parent.parent);
							// var classFn = workflowFactory[parent.class];
							// console.log(classFn ,childWorkflow.class)
							// var instance = new classFn(parent.parent);
							// instance.parentWorkflow = workflowId;

							_context8.next = 94;
							return parentJournal.append({ type: "FailedChildWorkflow", date: entry.date, result: entry.result, dispatchId: workflowId });

						case 94:
							_context8.next = 96;
							return _taint({ workflowId: parent.parent, recovery: recovery });

						case 96:
							_context8.next = 98;
							return journal.append({ type: "Archive", date: new Date() });

						case 98:
							return _context8.abrupt('return');

						case 100:
							i++;
							_context8.next = 19;
							break;

						case 103:
							if (!(lastDecisionTaskState === 'start' && moment().diff(moment(lastDecisionTaskDate).utc(), 'minutes') > 5)) {
								_context8.next = 110;
								break;
							}

							_context8.next = 106;
							return journal.append({ type: "DecisionTaskTimeOut", timeout: "StartToComplete", date: new Date() });

						case 106:
							_logger2.default.warn("Taint - Start DecisionTaskTimeOut " + workflowId);
							_context8.next = 109;
							return _taint({ workflowId: workflowId, recovery: recovery });

						case 109:
							return _context8.abrupt('return');

						case 110:
							if (!(lastDecisionTaskState === 'schedule' && moment().diff(moment(lastDecisionTaskDate).utc(), 'minutes') > 15)) {
								_context8.next = 117;
								break;
							}

							_context8.next = 113;
							return journal.append({ type: "DecisionTaskTimeOut", timeout: "ScheduleToComplete", date: new Date() });

						case 113:
							_logger2.default.warn("Taint - Schedule DecisionTaskTimeOut " + workflowId);
							_context8.next = 116;
							return _taint({ workflowId: workflowId, recovery: recovery });

						case 116:
							return _context8.abrupt('return');

						case 117:
							if (!(lastDecisionTaskState === 'queue' && moment().diff(moment(lastDecisionTaskDate).utc(), 'minutes') > 15)) {
								_context8.next = 124;
								break;
							}

							_context8.next = 120;
							return journal.append({ type: "DecisionTaskTimeOut", timeout: "QueueToComplete", date: new Date() });

						case 120:
							_logger2.default.warn("Taint - Queue DecisionTaskTimeOut " + workflowId);
							_context8.next = 123;
							return _taint({ workflowId: workflowId, recovery: recovery });

						case 123:
							return _context8.abrupt('return');

						case 124:
							tasksIds = (0, _keys2.default)(tasks);
							i = 0;

						case 126:
							if (!(i < tasksIds.length)) {
								_context8.next = 162;
								break;
							}

							taskId = tasksIds[i];
							task = tasks[taskId];

							if (!task.finished) {
								_context8.next = 131;
								break;
							}

							return _context8.abrupt('continue', 159);

						case 131:
							if (!task.queued) {
								_context8.next = 133;
								break;
							}

							return _context8.abrupt('continue', 159);

						case 133:
							_logger2.default.debug("activity state:", task, taskId);
							_context8.next = 136;
							return (0, _activity_state_helper2.default)(taskId, journal, entries);

						case 136:
							state = _context8.sent;

							if (!(task.schedule && !task.started)) {
								_context8.next = 153;
								break;
							}

							if (!(task.failedCount > process.env.TASK_RETRY_COUNT)) {
								_context8.next = 147;
								break;
							}

							// fail entire workflow
							_logger2.default.debug("task failed 5 time. failing workflow", workflowId);
							_context8.next = 142;
							return journal.append({ type: "WorkflowFailed", date: new Date(), result: 'task ' + taskId + ' failed' });

						case 142:
							_context8.next = 144;
							return _taint({ workflowId: workflowId, recovery: recovery });

						case 144:
							return _context8.abrupt('return');

						case 147:
							_context8.next = 149;
							return journal.append({ type: "QueueActivity", date: new Date(), dispatchId: taskId });

						case 149:
							_context8.next = 151;
							return activityTasks.putJob({ workflowId: workflowId, taskId: taskId });

						case 151:
							_context8.next = 159;
							break;

						case 153:
							if (!state.started) {
								_context8.next = 159;
								break;
							}

							if (!(moment().diff(moment(state.last_activity).utc(), 'minutes') > process.env.ACTIVITY_HEARTBEAT_TIMEOUT)) {
								_context8.next = 159;
								break;
							}

							// handle timeout
							_logger2.default.info("TimedOutActivity");
							_context8.next = 158;
							return journal.append({ type: "TimedOutActivity", date: new Date(), dispatchId: taskId });

						case 158:
							needANewDecisionTask = true;
							// throw new WorkflowDecisionScheduleActivity("HeartBeeat");

						case 159:
							i++;
							_context8.next = 126;
							break;

						case 162:
							childWorkflowsIds = (0, _keys2.default)(childWorkflows);
							i = 0;

						case 164:
							if (!(i < childWorkflowsIds.length)) {
								_context8.next = 203;
								break;
							}

							childWorkflowId = childWorkflowsIds[i];
							childWorkflow = childWorkflows[childWorkflowId];

							if (!childWorkflow.finished) {
								_context8.next = 169;
								break;
							}

							return _context8.abrupt('continue', 200);

						case 169:
							childJournal = _client4.default.getJournal(childWorkflowId);
							// var state = await workflowStateFromHistory(childJournal);

							_context8.next = 172;
							return (0, _activity_state_helper2.default)(childWorkflowId, journal, entries);

						case 172:
							state = _context8.sent;

							_logger2.default.debug("wf state:", childWorkflowId, childWorkflow.finished, state.last_activity);

							if (!(childWorkflow.failed && childWorkflow.failedCount > WORKFLOW_RETRY_COUNT)) {
								_context8.next = 181;
								break;
							}

							_context8.next = 177;
							return journal.append({ type: "WorkflowFailed", date: new Date(), result: 'workflow ' + childWorkflowId + ' failed' });

						case 177:
							_logger2.default.warn("failing workflow:", workflowId);
							_context8.next = 180;
							return _taint({ workflowId: workflowId, recovery: recovery });

						case 180:
							return _context8.abrupt('return');

						case 181:
							if (!(childWorkflow.schedule && !childWorkflow.started)) {
								_context8.next = 196;
								break;
							}

							// create a new workflow
							// console.log("childWorkflow",childWorkflowId,childWorkflow);				
							classFn = _workflow_factory2.default[childWorkflow.class];

							// console.log(classFn ,childWorkflow.class)
							// var instance = new classFn(childWorkflowId);
							// instance.parentWorkflow = workflowId;

							// TODO: need to enable for retries
							// await childJournal.clear();		
							// await delay(1000);

							_logger2.default.info("start child workflow " + childWorkflowId);
							_context8.next = 186;
							return journal.append({ type: "StartChildWorkflow", date: new Date(), dispatchId: childWorkflowId, class: childWorkflow.class, name: childWorkflow.name });

						case 186:
							_context8.next = 188;
							return childJournal.append({ type: "WorkflowStarted", date: new Date(), args: childWorkflow.args, name: childWorkflow.name, class: childWorkflow.class, parent: workflowId });

						case 188:
							_context8.next = 190;
							return childJournal.append({ type: "DecisionTaskSchedule", date: new Date() });

						case 190:
							_context8.next = 192;
							return childJournal.append({ type: "DecisionTaskQueued", date: new Date() });

						case 192:
							_context8.next = 194;
							return decisionTasks.putJob({ workflowId: childWorkflowId });

						case 194:
							_context8.next = 200;
							break;

						case 196:
							if (!(!childWorkflow.finished && !childWorkflow.failed)) {
								_context8.next = 200;
								break;
							}

							if (!(recovery || moment().diff(moment(state.last_activity).utc(), 'minutes') > process.env.CHILD_WORKFLOW_HEARTBEAT_TIMEOUT)) {
								_context8.next = 200;
								break;
							}

							_context8.next = 200;
							return _taint({ workflowId: childWorkflowId, recovery: recovery });

						case 200:
							i++;
							_context8.next = 164;
							break;

						case 203:
							if (!(needANewDecisionTask && lastDecisionTaskState !== 'queue' || recovery)) {
								_context8.next = 210;
								break;
							}

							_context8.next = 206;
							return journal.append({ type: "DecisionTaskSchedule", date: new Date() });

						case 206:
							_context8.next = 208;
							return journal.append({ type: "DecisionTaskQueued", date: new Date() });

						case 208:
							_context8.next = 210;
							return decisionTasks.putJob({ workflowId: workflowId });

						case 210:
							_logger2.default.debug("Done tainting " + workflowId);
							// can be done periodically
							// check for timeouts: decision task timeouts, child workflow timeouts, main workflow timeouts, activity timeouts (heartbeat, scheduletocomplete, scheduletostart, starttocomplete)
							// check for needed dispatch for activities
							// check for needed dispatch for new workflows
							// check for needed dispatch for decision tasks

						case 211:
						case 'end':
							return _context8.stop();
					}
				}
			}, _callee8, this);
		}));

		function taint(_x7) {
			return _ref13.apply(this, arguments);
		}

		return taint;
	}()
	// add decision task schedule when recieves an important change
	// complete workflow
	// fails
	// complete activity
	// timeouts

};
var server = jayson.server(srv);

var http = server.http();
if (process.env.FJS_RECOVER === 'true') {
	srv.recover();
}

exports.default = http;