'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _server = require('./job_queue/server');

var _server2 = _interopRequireDefault(_server);

var _server3 = require('./journal/server');

var _server4 = _interopRequireDefault(_server3);

var _server5 = require('./scheduler/server');

var _server6 = _interopRequireDefault(_server5);

var _server7 = require('./workers/server');

var _server8 = _interopRequireDefault(_server7);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function startAll() {
    if (process.env.ENABLE_JOBQUEUE) _server2.default.listen(4002);
    if (process.env.ENABLE_JOURNAL) _server4.default.listen(4001);
    if (process.env.ENABLE_SCHEDULER) _server6.default.listen(4003);
    _server8.default.runAll().then(function () {
        return _logger2.default.info("ready");
    });
}
function stopAll() {
    _server8.default.stop = true;
    if (process.env.ENABLE_JOURNAL) _server4.default.close();
    if (process.env.ENABLE_SCHEDULER) _server6.default.close();
    if (process.env.ENABLE_JOBQUEUE) _server2.default.close();
}

exports.default = {
    jobQueueServer: _server2.default,
    journalServer: _server4.default,
    schedulerServer: _server6.default,
    workerServer: _server8.default,
    startAll: startAll,
    stopAll: stopAll
};