'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var entries = {};

function initializeUtil(name, pluginName) {
    function loadPlugin(pluginName) {
        if (!pluginName) return null;
        try {

            var module = require('../plugins/' + name + '/' + pluginName);
            console.log('loaded ../plugins/' + name + '/' + pluginName);
            return module.default;
        } catch (e) {
            console.log(e);
            return null;
        }
    }

    function getUtil() {
        var upName = name.toUpperCase();
        return process.env['ENABLE_' + upName] === 'true' ? loadPlugin(pluginName || process.env[upName + '_PLUGIN']) || loadPlugin('default') || loadPlugin('disabled') || { init: function init() {} } : loadPlugin('disabled') || { init: function init() {} };
    }
    var plugin = getUtil();

    plugin.init();
    return plugin;
}

exports.default = {
    Logger: initializeUtil('logger'),
    initializeUtil: initializeUtil
};