'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var DoDecisionTask = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(job) {
		var journal, entries, params, classFn, instance;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.prev = 0;

						_logger2.default.debug("DoDecisionTask " + job.workflowId);
						journal = _client2.default.getJournal(job.workflowId);
						_context.next = 5;
						return journal.getEntries();

					case 5:
						entries = _context.sent;

						if (!entries.find(function (e) {
							return e.type === 'Archive';
						})) {
							_context.next = 9;
							break;
						}

						_logger2.default.debug("DONE - DoDecisionTask - Archives" + job.workflowId);
						return _context.abrupt('return');

					case 9:
						params = entries.find(function (e) {
							return e.type === 'WorkflowStarted';
						});

						if (params) {
							_context.next = 13;
							break;
						}

						_logger2.default.warn("DONE - DoDecisionTask - no WorkflowStarted " + job.workflowId);
						return _context.abrupt('return');

					case 13:
						classFn = _workflow_factory2.default[params.class];
						instance = new classFn(job.workflowId);

						instance.mainRun = true;
						_context.next = 18;
						return instance[params.name].apply(instance, (0, _toConsumableArray3.default)((0, _values2.default)(params.args)));

					case 18:
						_logger2.default.debug("DONE - DoDecisionTask " + job.workflowId);
						_context.next = 24;
						break;

					case 21:
						_context.prev = 21;
						_context.t0 = _context['catch'](0);

						_logger2.default.warn("FAIL - DoDecisionTask " + job.workflowId, _context.t0);

					case 24:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this, [[0, 21]]);
	}));

	return function DoDecisionTask(_x) {
		return _ref.apply(this, arguments);
	};
}();

var DoActivityTask = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(job) {
		var instance, _instance, journal, entries, params, classFn, state, dispatchId, paramsActivity, res;

		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						// console.log("need to do ", job);	
						instance = void 0;
						_context2.prev = 1;

						_logger2.default.debug("DoActivityTask " + job.taskId);
						journal = _client2.default.getJournal(job.workflowId);
						_context2.next = 6;
						return journal.getEntries();

					case 6:
						entries = _context2.sent;
						params = entries.find(function (e) {
							return e.type == 'WorkflowStarted';
						});
						classFn = _workflow_factory2.default[params.class];

						instance = new classFn(job.workflowId);
						_context2.next = 12;
						return (0, _activity_state_helper2.default)(job.taskId, journal, entries);

					case 12:
						state = _context2.sent;

						if (!state.finished) {
							_context2.next = 16;
							break;
						}

						_logger2.default.debug("ALREADY DONE - DoActivityTask " + job.taskId);
						return _context2.abrupt('return');

					case 16:
						dispatchId = job.taskId;
						paramsActivity = entries.find(function (e) {
							return e.dispatchId == dispatchId && e.type === "ScheduleActivity";
						});

						instance.activityMode = true;
						_context2.next = 21;
						return instance.journal.append({ type: "StartedActivity", date: new Date(), dispatchId: dispatchId, args: paramsActivity.args, name: paramsActivity.name });

					case 21:
						_context2.next = 23;
						return (_instance = instance)[paramsActivity.name].apply(_instance, (0, _toConsumableArray3.default)((0, _values2.default)(paramsActivity.args)));

					case 23:
						res = _context2.sent;
						_context2.next = 26;
						return instance.journal.append({ type: "FinishedActivity", date: new Date(), dispatchId: dispatchId, result: res });

					case 26:
						_logger2.default.debug("DONE - DoActivityTask " + job.taskId);
						_context2.next = 35;
						break;

					case 29:
						_context2.prev = 29;
						_context2.t0 = _context2['catch'](1);

						_logger2.default.warn(_context2.t0);
						_context2.next = 34;
						return instance.journal.append({ type: "FailedActivity", date: new Date(), dispatchId: dispatchId, error: _context2.t0.toString() });

					case 34:
						_logger2.default.debug("FAILED - DoActivityTask " + job.taskId);

					case 35:
						// console.log(instance.journal.getEntries());
						instance.scheduler.taint();

					case 36:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this, [[1, 29]]);
	}));

	return function DoActivityTask(_x2) {
		return _ref2.apply(this, arguments);
	};
}();

var PeriodicDoDecisionTask = function () {
	var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(queue, worker) {
		var job;
		return _regenerator2.default.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						if (!worker.stop) {
							_context3.next = 2;
							break;
						}

						return _context3.abrupt('return');

					case 2:
						_context3.prev = 2;
						_context3.next = 5;
						return queue.getJob();

					case 5:
						job = _context3.sent;

						if (!job) {
							_context3.next = 11;
							break;
						}

						_context3.next = 9;
						return DoDecisionTask(job);

					case 9:
						_context3.next = 13;
						break;

					case 11:
						_context3.next = 13;
						return delay(500);

					case 13:
						_context3.next = 17;
						break;

					case 15:
						_context3.prev = 15;
						_context3.t0 = _context3['catch'](2);

					case 17:
						setTimeout(function () {
							PeriodicDoDecisionTask(queue, worker);
						}, 0);

					case 18:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, this, [[2, 15]]);
	}));

	return function PeriodicDoDecisionTask(_x3, _x4) {
		return _ref3.apply(this, arguments);
	};
}();

var PeriodicDoActivityTask = function () {
	var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(queue, worker) {
		var job;
		return _regenerator2.default.wrap(function _callee4$(_context4) {
			while (1) {
				switch (_context4.prev = _context4.next) {
					case 0:
						if (!worker.stop) {
							_context4.next = 2;
							break;
						}

						return _context4.abrupt('return');

					case 2:
						_context4.prev = 2;
						_context4.next = 5;
						return queue.getJob();

					case 5:
						job = _context4.sent;

						if (!job) {
							_context4.next = 11;
							break;
						}

						_context4.next = 9;
						return DoActivityTask(job);

					case 9:
						_context4.next = 13;
						break;

					case 11:
						_context4.next = 13;
						return delay(500);

					case 13:
						_context4.next = 17;
						break;

					case 15:
						_context4.prev = 15;
						_context4.t0 = _context4['catch'](2);

					case 17:
						setTimeout(function () {
							PeriodicDoActivityTask(queue, worker);
						}, 0);

					case 18:
					case 'end':
						return _context4.stop();
				}
			}
		}, _callee4, this, [[2, 15]]);
	}));

	return function PeriodicDoActivityTask(_x5, _x6) {
		return _ref4.apply(this, arguments);
	};
}();

var _client = require('./journal/client');

var _client2 = _interopRequireDefault(_client);

var _workflow_factory = require('./workflow_factory');

var _workflow_factory2 = _interopRequireDefault(_workflow_factory);

var _client3 = require('./job_queue/client');

var _client4 = _interopRequireDefault(_client3);

var _activity_state_helper = require('./activity_state_helper');

var _activity_state_helper2 = _interopRequireDefault(_activity_state_helper);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function delay(time) {
	return new _promise2.default(function (fulfill) {
		setTimeout(fulfill, time);
	});
}

var Worker = function () {
	function Worker() {
		(0, _classCallCheck3.default)(this, Worker);
	}

	(0, _createClass3.default)(Worker, [{
		key: 'runAll',
		value: function () {
			var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
				var i;
				return _regenerator2.default.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								for (i = 0; i < process.env.FJS_DECISION_WORKERS || 0; i++) {
									PeriodicDoDecisionTask(_client4.default.getJobQueue("decisions"), this);
								}
								for (i = 0; i < process.env.FJS_ACTIVITY_WORKERS || 0; i++) {
									PeriodicDoActivityTask(_client4.default.getJobQueue("activities"), this);
								}

							case 2:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, this);
			}));

			function runAll() {
				return _ref5.apply(this, arguments);
			}

			return runAll;
		}()
	}]);
	return Worker;
}();

exports.default = Worker;