'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _client = require('./journal/client');

var _client2 = _interopRequireDefault(_client);

var _client3 = require('./scheduler/client');

var _client4 = _interopRequireDefault(_client3);

var _workflow_signals = require('./workflow_signals');

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _workflow_state_helper = require('./workflow_state_helper');

var _workflow_state_helper2 = _interopRequireDefault(_workflow_state_helper);

var _activity_state_helper = require('./activity_state_helper');

var _activity_state_helper2 = _interopRequireDefault(_activity_state_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WorkflowController = function () {
	function WorkflowController(workflowId, activityMode) {
		(0, _classCallCheck3.default)(this, WorkflowController);

		this.workflowId = workflowId;
		this.lastDispatchId = 0;
		this.activityMode = activityMode;
		this.journal = _client2.default.getJournal(workflowId);
		this.scheduler = _client4.default.getScheduler(workflowId);
	}

	(0, _createClass3.default)(WorkflowController, [{
		key: 'workflowStateFromHistory',
		value: function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(journal) {
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								journal = journal || this.journal;
								return _context.abrupt('return', (0, _workflow_state_helper2.default)(journal));

							case 2:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function workflowStateFromHistory(_x) {
				return _ref.apply(this, arguments);
			}

			return workflowStateFromHistory;
		}()
	}, {
		key: 'stateFromHistory',
		value: function () {
			var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dispatchId, journal) {
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								journal = journal || this.journal;
								return _context2.abrupt('return', (0, _activity_state_helper2.default)(dispatchId, journal));

							case 2:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function stateFromHistory(_x2, _x3) {
				return _ref2.apply(this, arguments);
			}

			return stateFromHistory;
		}()
	}, {
		key: 'newDispatchID',
		value: function newDispatchID(name) {
			if (name) {
				return this.workflowId + "." + name + "." + ++this.lastDispatchId;
			}
			return this.workflowId + "." + ++this.lastDispatchId;
		}
	}, {
		key: 'sleep',
		value: function () {
			var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(durationInSeconds) {
				var timerId, entries, timerFired, timerSetup, threshold, timeLeft;
				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								// setup a timer
								timerId = this.newDispatchID();
								_context3.next = 3;
								return this.journal.getEntries();

							case 3:
								entries = _context3.sent;
								timerFired = entries.find(function (e) {
									return e.type === 'TimerFired' && e.timerId == timerId;
								});

								if (!timerFired) {
									_context3.next = 8;
									break;
								}

								_logger2.default.debug("timer already fired " + timerId);
								return _context3.abrupt('return');

							case 8:
								timerSetup = entries.find(function (e) {
									return e.type === 'TimerSetup' && e.timerId == timerId;
								});

								if (timerSetup) {
									_context3.next = 12;
									break;
								}

								_logger2.default.debug("setting up time " + timerId);
								throw new _workflow_signals.WorkflowTimerDecision(durationInSeconds, timerId);

							case 12:
								threshold = new Date(timerSetup.date.getTime() + durationInSeconds * 1000);
								timeLeft = threshold.getTime() - new Date().getTime();

								if (!(timeLeft <= 0)) {
									_context3.next = 19;
									break;
								}

								// should be moved to scheduler
								// should add have new decision task.						
								// await this.journal.append({type:"TimerFired", date: new Date(),timerId});
								_logger2.default.debug("done sleeping" + timerId);
								return _context3.abrupt('return');

							case 19:
								_logger2.default.debug("still sleeping " + timerId);
								throw new _workflow_signals.WorkflowNoDecision();

							case 21:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this);
			}));

			function sleep(_x4) {
				return _ref3.apply(this, arguments);
			}

			return sleep;
		}()
	}, {
		key: 'parallel_do',
		value: function () {
			var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(list, fn) {
				var exceptions, results, i, thing, result;
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								// batch all exceptions
								exceptions = [];
								results = [];
								i = list.length - 1;

							case 3:
								if (!(i >= 0)) {
									_context4.next = 18;
									break;
								}

								thing = list[i];
								_context4.prev = 5;
								_context4.next = 8;
								return fn(thing);

							case 8:
								result = _context4.sent;

								results.push(result);
								_context4.next = 15;
								break;

							case 12:
								_context4.prev = 12;
								_context4.t0 = _context4['catch'](5);

								exceptions.push(_context4.t0);
								// aggregate

							case 15:
								i--;
								_context4.next = 3;
								break;

							case 18:
								if (!(exceptions.length > 0)) {
									_context4.next = 20;
									break;
								}

								throw new _workflow_signals.WorkflowDecisionMultipleDecisions(exceptions);

							case 20:
								return _context4.abrupt('return', results);

							case 21:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, this, [[5, 12]]);
			}));

			function parallel_do(_x5, _x6) {
				return _ref4.apply(this, arguments);
			}

			return parallel_do;
		}()
	}, {
		key: 'waitForSignal',
		value: function () {
			var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(signalId) {
				var entries, signalFire;
				return _regenerator2.default.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								_context5.next = 2;
								return this.journal.getEntries();

							case 2:
								entries = _context5.sent;
								signalFire = entries.find(function (e) {
									return e.type === 'SignalFired' && e.signalId == signalId;
								});

								if (!signalFire) {
									_context5.next = 6;
									break;
								}

								return _context5.abrupt('return', signalFire.result);

							case 6:
								throw new _workflow_signals.WorkflowNoDecision();

							case 7:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, this);
			}));

			function waitForSignal(_x7) {
				return _ref5.apply(this, arguments);
			}

			return waitForSignal;
		}()
	}, {
		key: 'doHuman',
		value: function () {
			var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(_ref7) {
				var prepare = _ref7.prepare,
				    process = _ref7.process,
				    payload = _ref7.payload,
				    id = _ref7.id;
				var result;
				return _regenerator2.default.wrap(function _callee6$(_context6) {
					while (1) {
						switch (_context6.prev = _context6.next) {
							case 0:
								_context6.next = 2;
								return prepare(payload, id);

							case 2:
								_context6.next = 4;
								return this.waitForSignal(id);

							case 4:
								result = _context6.sent;
								_context6.next = 7;
								return process(result, id);

							case 7:
								return _context6.abrupt('return', _context6.sent);

							case 8:
							case 'end':
								return _context6.stop();
						}
					}
				}, _callee6, this);
			}));

			function doHuman(_x8) {
				return _ref6.apply(this, arguments);
			}

			return doHuman;
		}()
	}, {
		key: 'continueAsNew',
		value: function () {
			var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
				var _args7 = arguments;
				return _regenerator2.default.wrap(function _callee7$(_context7) {
					while (1) {
						switch (_context7.prev = _context7.next) {
							case 0:
								throw new _workflow_signals.WorkflowDecisionContinueAsNew(_args7);

							case 1:
							case 'end':
								return _context7.stop();
						}
					}
				}, _callee7, this);
			}));

			function continueAsNew() {
				return _ref8.apply(this, arguments);
			}

			return continueAsNew;
		}()
	}]);
	return WorkflowController;
}();

exports.default = WorkflowController;