'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var workflowStateFromHistory = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(journal, entries) {
		var state, timedOut, failures, i, entry;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						if (entries) {
							_context.next = 4;
							break;
						}

						_context.next = 3;
						return journal.getEntries();

					case 3:
						entries = _context.sent;

					case 4:
						state = { notFound: true };
						timedOut = 0;
						failures = 0;
						i = 0;

					case 8:
						if (!(i < entries.length)) {
							_context.next = 25;
							break;
						}

						entry = entries[i];
						// if schedule event, set state to scheduled

						if (!(entry.type == 'WorkflowStarted')) {
							_context.next = 14;
							break;
						}

						state = { started: true, name: entry.name, args: entry.args };
						_context.next = 21;
						break;

					case 14:
						if (!(entry.type == 'WorkflowComplete')) {
							_context.next = 20;
							break;
						}

						state = { finished: true, result: entry.result };
						state.last_activity = entry.date;
						return _context.abrupt('return', state);

					case 20:
						if (entry.type == 'WorkflowFailed') {
							state = { failed: true, result: entry.result };
						} else if (entry.type == 'WorkflowTimeout') {
							state = { timeout: true };
						}

					case 21:
						if (state) {
							state.last_activity = entry.date;
						}

					case 22:
						i++;
						_context.next = 8;
						break;

					case 25:
						return _context.abrupt('return', state);

					case 26:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function workflowStateFromHistory(_x, _x2) {
		return _ref.apply(this, arguments);
	};
}();

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = workflowStateFromHistory;